diff --git a/ext/drreg/drreg.c b/ext/drreg/drreg.c
index 8e36ea7cecf..42605333cc6 100644
--- a/ext/drreg/drreg.c
+++ b/ext/drreg/drreg.c
@@ -1609,9 +1609,19 @@ is_our_spill_or_restore(void *drcontext, instr_t *instr, bool *spill OUT,
                 opnd_get_disp(dr_reg_spill_slot_opnd(drcontext, SPILL_SLOT_1));
             uint DR_max_offs = opnd_get_disp(
                 dr_reg_spill_slot_opnd(drcontext, dr_max_opnd_accessible_spill_slot()));
-            if (DR_min_offs > DR_max_offs)
-                DR_min_offs = DR_max_offs;
-            slot = (offs - DR_min_offs) / sizeof(reg_t);
+            if (DR_min_offs > DR_max_offs) {
+                if (offs > DR_min_offs) {
+                    slot = (offs - DR_min_offs) / sizeof(reg_t);
+                } else {
+                    slot = (DR_min_offs - offs) / sizeof(reg_t);
+                }
+            } else {
+                if (offs > DR_max_offs) {
+                    slot = (offs - DR_max_offs) / sizeof(reg_t);
+                } else {
+                    slot = (offs - DR_min_offs) / sizeof(reg_t);
+                }
+            }
             uint max_DR_slot = (uint)dr_max_opnd_accessible_spill_slot();
             if (slot > max_DR_slot) {
                 /* This is not a drreg spill, but some TLS access by
@@ -1774,9 +1784,10 @@ drreg_event_restore_state(void *drcontext, bool restore_memory,
     for (reg = DR_REG_START_GPR; reg <= DR_REG_STOP_GPR; reg++) {
         if (spilled_to[GPR_IDX(reg)] < MAX_SPILLS) {
             reg_t val = get_spilled_value(drcontext, spilled_to[GPR_IDX(reg)]);
-            LOG(drcontext, DR_LOG_ALL, 3, "%s: restoring %s from " PFX " to " PFX "\n",
-                __FUNCTION__, get_register_name(reg), reg_get_value(reg, info->mcontext),
-                val);
+            LOG(drcontext, DR_LOG_ALL, 3,
+                "%s: restoring %s from slot %d from " PFX " to " PFX "\n", __FUNCTION__,
+                get_register_name(reg), spilled_to[GPR_IDX(reg)],
+                reg_get_value(reg, info->mcontext), val);
             reg_set_value(reg, info->mcontext, val);
         }
     }
diff --git a/suite/tests/client-interface/drreg-test-shared.h b/suite/tests/client-interface/drreg-test-shared.h
index b5ab614e20b..bb36cef68b3 100644
--- a/suite/tests/client-interface/drreg-test-shared.h
+++ b/suite/tests/client-interface/drreg-test-shared.h
@@ -93,3 +93,9 @@
 
 #define DRREG_TEST_5_ASM MAKE_HEX_ASM(DRREG_TEST_CONST(5))
 #define DRREG_TEST_5_C MAKE_HEX_C(DRREG_TEST_CONST(5))
+
+#define DRREG_TEST_6_ASM MAKE_HEX_ASM(DRREG_TEST_CONST(6))
+#define DRREG_TEST_6_C MAKE_HEX_C(DRREG_TEST_CONST(6))
+
+#define DRREG_TEST_7_ASM MAKE_HEX_ASM(DRREG_TEST_CONST(7))
+#define DRREG_TEST_7_C MAKE_HEX_C(DRREG_TEST_CONST(7))
diff --git a/suite/tests/client-interface/drreg-test.c b/suite/tests/client-interface/drreg-test.c
index be0e84feb95..9256dc78e20 100644
--- a/suite/tests/client-interface/drreg-test.c
+++ b/suite/tests/client-interface/drreg-test.c
@@ -30,6 +30,11 @@
  * DAMAGE.
  */
 
+/* clang-format off */
+/* XXX: clang-format incorrectly detected a tab difference at "clang-format on"
+ * below. This is why "clang-format off" has been moved outside the ifdef until
+ * bug is fixed.
+ */
 #ifndef ASM_CODE_ONLY /* C code */
 #    include "tools.h"
 #    include "drreg-test-shared.h"
@@ -42,6 +47,8 @@ void
 test_asm_faultA();
 void
 test_asm_faultB();
+void
+test_asm_faultC();
 
 static SIGJMP_BUF mark;
 
@@ -61,6 +68,17 @@ handle_signal(int signal, siginfo_t *siginfo, ucontext_t *ucxt)
     }
     SIGLONGJMP(mark, 1);
 }
+
+static void
+handle_signal2(int signal, siginfo_t *siginfo, ucontext_t *ucxt)
+{
+    if (signal == SIGILL) {
+        sigcontext_t *sc = SIGCXT_FROM_UCXT(ucxt);
+        if (sc->TEST_REG_SIG != DRREG_TEST_7_C)
+            print("ERROR: spilled register value was not preserved!\n");
+    }
+    SIGLONGJMP(mark, 1);
+}
 #    elif defined(WINDOWS)
 #        include <windows.h>
 static LONG WINAPI
@@ -75,6 +93,16 @@ handle_exception(struct _EXCEPTION_POINTERS *ep)
     }
     SIGLONGJMP(mark, 1);
 }
+
+static LONG WINAPI
+handle_exception2(struct _EXCEPTION_POINTERS *ep)
+{
+    if (ep->ExceptionRecord->ExceptionCode == EXCEPTION_ILLEGAL_INSTRUCTION) {
+        if (ep->ContextRecord->TEST_REG_CXT != DRREG_TEST_7_C)
+            print("ERROR: spilled register value was not preserved!\n");
+    }
+    SIGLONGJMP(mark, 1);
+}
 #    endif
 
 int
@@ -101,6 +129,17 @@ main(int argc, const char *argv[])
         test_asm_faultB();
     }
 
+#    if defined(UNIX)
+    intercept_signal(SIGILL, (handler_3_t)&handle_signal2, false);
+#    elif defined(WINDOWS)
+    SetUnhandledExceptionFilter(&handle_exception2);
+#    endif
+
+    /* Test fault aflags restore */
+    if (SIGSETJMP(mark) == 0) {
+        test_asm_faultC();
+    }
+
     /* XXX i#511: add more fault tests and other tricky corner cases */
 
     print("drreg-test finished\n");
@@ -110,7 +149,6 @@ main(int argc, const char *argv[])
 #else /* asm code *************************************************************/
 #    include "asm_defines.asm"
 #    include "drreg-test-shared.h"
-/* clang-format off */
 START_FILE
 
 #ifdef X64
@@ -334,6 +372,32 @@ GLOBAL_LABEL(FUNCNAME:)
         END_FUNC(FUNCNAME)
 #undef FUNCNAME
 
+#define FUNCNAME test_asm_faultC
+        DECLARE_FUNC_SEH(FUNCNAME)
+GLOBAL_LABEL(FUNCNAME:)
+#ifdef X86
+        PUSH_CALLEE_SAVED_REGS()
+        sub      REG_XSP, FRAME_PADDING /* align */
+        END_PROLOG
+
+        jmp      test6
+        /* Test 6: fault aflags restore */
+     test6:
+        mov      TEST_REG_ASM, DRREG_TEST_6_ASM
+        mov      TEST_REG_ASM, DRREG_TEST_6_ASM
+        nop
+        mov      TEST_REG_ASM, DRREG_TEST_7_ASM
+        nop
+        ud2
+
+        jmp      epilog6
+     epilog6:
+        add      REG_XSP, FRAME_PADDING /* make a legal SEH64 epilog */
+        POP_CALLEE_SAVED_REGS()
+        ret
+#endif
+        END_FUNC(FUNCNAME)
+#undef FUNCNAME
 END_FILE
-/* clang-format on */
 #endif
+/* clang-format on */
diff --git a/suite/tests/client-interface/drreg-test.dll.c b/suite/tests/client-interface/drreg-test.dll.c
index f3e06f5f21e..a0b30a21759 100644
--- a/suite/tests/client-interface/drreg-test.dll.c
+++ b/suite/tests/client-interface/drreg-test.dll.c
@@ -247,7 +247,7 @@ event_app_instruction(void *drcontext, void *tag, instrlist_t *bb, instr_t *inst
         }
     } else if (subtest == DRREG_TEST_4_C || subtest == DRREG_TEST_5_C) {
         /* Cross-app-instr aflags test */
-        dr_log(drcontext, DR_LOG_ALL, 1, "drreg test #4\n");
+        dr_log(drcontext, DR_LOG_ALL, 1, "drreg test #4/5\n");
         if (instr_is_label(inst)) {
             res = drreg_reserve_aflags(drcontext, bb, inst);
             CHECK(res == DRREG_SUCCESS, "reserve of aflags should work");
@@ -265,6 +265,16 @@ event_app_instruction(void *drcontext, void *tag, instrlist_t *bb, instr_t *inst
             res = drreg_unreserve_aflags(drcontext, bb, inst);
             CHECK(res == DRREG_SUCCESS, "unreserve of aflags should work");
         }
+    } else if (subtest == DRREG_TEST_6_C) {
+        /* Save the 3rd DR slot at the label, restore register after
+         * the xl8 point in this test.
+         */
+        dr_log(drcontext, DR_LOG_ALL, 1, "drreg test #6\n");
+        if (instr_is_label(inst)) {
+            dr_save_reg(drcontext, bb, inst, TEST_REG, 2);
+        } else if (drmgr_is_last_instr(drcontext, inst)) {
+            dr_restore_reg(drcontext, bb, inst, TEST_REG, 2);
+        }
     }
 
     drvector_delete(&allowed);
